/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"reflect"
)

// LevelOfAssuranceAPIService LevelOfAssuranceAPI service
type LevelOfAssuranceAPIService service

type LevelOfAssuranceGetRequest struct {
	ctx        context.Context
	ApiService *LevelOfAssuranceAPIService
	offset     *int32
	limit      *int32
	token      *string
	sort       *[]string
	filter     *[]string
	field      *[]string
}

func (r LevelOfAssuranceGetRequest) Offset(offset int32) LevelOfAssuranceGetRequest {
	r.offset = &offset
	return r
}

func (r LevelOfAssuranceGetRequest) Limit(limit int32) LevelOfAssuranceGetRequest {
	r.limit = &limit
	return r
}

func (r LevelOfAssuranceGetRequest) Token(token string) LevelOfAssuranceGetRequest {
	r.token = &token
	return r
}

func (r LevelOfAssuranceGetRequest) Sort(sort []string) LevelOfAssuranceGetRequest {
	r.sort = &sort
	return r
}

func (r LevelOfAssuranceGetRequest) Filter(filter []string) LevelOfAssuranceGetRequest {
	r.filter = &filter
	return r
}

func (r LevelOfAssuranceGetRequest) Field(field []string) LevelOfAssuranceGetRequest {
	r.field = &field
	return r
}

func (r LevelOfAssuranceGetRequest) Execute() (*LevelOfAssuranceEnumerateEnvelope, *http.Response, error) {
	return r.ApiService.LevelOfAssuranceGetExecute(r)
}

/*
LevelOfAssuranceGet Get all available LOAs.

	@param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
	@return LevelOfAssuranceGetRequest
*/
func (a *LevelOfAssuranceAPIService) LevelOfAssuranceGet(ctx context.Context) LevelOfAssuranceGetRequest {
	return LevelOfAssuranceGetRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//
//	@return LevelOfAssuranceEnumerateEnvelope
func (a *LevelOfAssuranceAPIService) LevelOfAssuranceGetExecute(r LevelOfAssuranceGetRequest) (*LevelOfAssuranceEnumerateEnvelope, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *LevelOfAssuranceEnumerateEnvelope
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "LevelOfAssuranceAPIService.LevelOfAssuranceGet")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/api/v1.0/LevelOfAssurance"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.offset != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "offset", r.offset, "")
	}
	if r.limit != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "limit", r.limit, "")
	}
	if r.token != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "token", r.token, "")
	}
	if r.sort != nil {
		t := *r.sort
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "sort", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "sort", t, "multi")
		}
	}
	if r.filter != nil {
		t := *r.filter
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "filter", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "filter", t, "multi")
		}
	}
	if r.field != nil {
		t := *r.field
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "field", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "field", t, "multi")
		}
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"text/plain", "application/json", "text/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
